

EXPORT BOOL WINAPI RGBtoHSV (int *p1, int p2, int p3 ,int p4)
{
	int R,G,B,min,H,S,V;

	R=p1[0];
	G=p1[1];
	B=p1[2];

	if (R<  0) R=  0;
	if (G<  0) G=  0;
	if (B<  0) B=  0;
	if (R>255) R=255;
	if (G>255) G=255;
	if (B>255) B=255;

	if (R>=G && R>=B) V=R;
	if (G>=R && G>=B) V=G;
	if (B>=R && B>=G) V=B;

	if (R<=G && R<=B) min=R;
	if (G<=R && G<=B) min=G;
	if (B<=R && B<=G) min=B;

	if (V==0) S=0; else S=(V-min)*255/V;

	if (R==G && R==B){
		H=0;
	}else{
		H=0;
		if (R>=G && G>=B) H=60*(G-B)/(R-B);	// R > G > B
		if (G>=R && R>=B) H=60*(G-R)/(G-B)+ 60;	// G > R > B
		if (G>=B && B>=R) H=60*(B-R)/(G-R)+120;	// G > B > R
		if (B>=G && G>=R) H=60*(B-G)/(B-R)+180;	// B > G > R
		if (B>=R && R>=G) H=60*(R-G)/(B-G)+240;	// B > R > G
		if (R>=B && B>=G) H=60*(R-B)/(R-G)+300;	// R > B > G
		H=H%360;
		H=(H*256+180)/360;
	}
	p1[0]=H;
	p1[1]=S;
	p1[2]=V;

	return 0;
}


EXPORT BOOL WINAPI HSVtoRGB (int *p1, int p2, int p3 ,int p4)
{
	int R,G,B,H,S,V,i0,i1,i2;

	H=p1[0];
	S=p1[1];
	V=p1[2];

	H=H&255;
	H=H*360/256;
	if (S<  0) S=  0;
	if (V<  0) V=  0;
	if (S>255) S=255;
	if (V>255) V=255;

	if (S==0){
		R=V; G=V; B=V;
	}else{
		i0=V;
		i1=(255-S)*V/255;
		i2=(i0-i1)*(H%60)/60;

		if      (H< 60) { R=i0;    G=i1+i2;  B=i1;		}
		else if (H<120) { R=i0-i2; G=i0;     B=i1;		}
		else if (H<180) { R=i1;    G=i0;     B=i1+i2;	}
		else if (H<240) { R=i1;    G=i0-i2;  B=i0;		}
		else if (H<300) { R=i1+i2; G=i1;     B=i0;		}
		else if (H<360) { R=i0;    G=i1;     B=i0-i2;	}
	}

	p1[0]=R;
	p1[1]=G;
	p1[2]=B;

	return 0;
}

EXPORT BOOL WINAPI RGBtoHSL (int *p1, int p2, int p3 ,int p4)
{
	int R,G,B,min,max,H,S,L;

	R=p1[0];
	G=p1[1];
	B=p1[2];

	if (R<  0) R=  0;
	if (G<  0) G=  0;
	if (B<  0) B=  0;
	if (R>255) R=255;
	if (G>255) G=255;
	if (B>255) B=255;

	if (R>=G && R>=B) max=R;
	if (G>=R && G>=B) max=G;
	if (B>=R && B>=G) max=B;

	if (R<=G && R<=B) min=R;
	if (G<=R && G<=B) min=G;
	if (B<=R && B<=G) min=B;

	L=(max+min)/2;

	if (max==min){
		S=0;
		H=0;
	}else{
		if (L<128)
			S=(max-min)*255/(max+min);
		else
			S=(max-min)*255/(510-max-min);

		H=0;
		if (R>=G && G>=B) H=60*(G-B)/(R-B);	// R > G > B
		if (G>=R && R>=B) H=60*(G-R)/(G-B)+ 60;	// G > R > B
		if (G>=B && B>=R) H=60*(B-R)/(G-R)+120;	// G > B > R
		if (B>=G && G>=R) H=60*(B-G)/(B-R)+180;	// B > G > R
		if (B>=R && R>=G) H=60*(R-G)/(B-G)+240;	// B > R > G
		if (R>=B && B>=G) H=60*(R-B)/(R-G)+300;	// R > B > G
		H=H%360;
		H=(H*256+180)/360;
	}
	p1[0]=H;
	p1[1]=S;
	p1[2]=L;

	return 0;
}

EXPORT BOOL WINAPI HSLtoRGB (int *p1, int p2, int p3 ,int p4)
{
	int H,S,L;
	int n1,n2,nH[3],i;

	H=p1[0];
	S=p1[1];
	L=p1[2];

	H=H&255;
	H=H*360/256;
	if (S<  0) S=  0;
	if (L<  0) L=  0;
	if (S>255) S=255;
	if (L>255) L=255;

	if (S==0){
		p1[0]=L;
		p1[1]=L;
		p1[2]=L;
	}else{

		if (L<128)	n2=(L*(S+255)+128)/255;
		else		n2=L+S-(L*S+128)/255;
		n1=L*2-n2;

		nH[0]=(H+120)%360;
		nH[1]=H;
		nH[2]=(H-120+360)%360;

		for(i=0; i<3; i++){
			if      (nH[i]< 60)	p1[i]=n2-n1*nH[i]/60+n1;
			else if (nH[i]<180)	p1[i]=n2;
			else if (nH[i]<240)	p1[i]=n2-n1*(240-nH[i])/60+n1;
			else				p1[i]=n1;
		}
	}

	return 0;
}

//YMCtoRGB͓
EXPORT BOOL WINAPI RGBtoYMC (int *p1, int p2, int p3 ,int p4)
{
	int R,G,B;
	R=p1[0];
	G=p1[1];
	B=p1[2];

	p1[0]=255-B;	//Y
	p1[1]=255-G;	//M
	p1[2]=255-R;	//C
	return 0;
}
EXPORT BOOL WINAPI RGBtoYUV (int *p1, int p2, int p3 ,int p4)
{
	int R,G,B,Y,U,V;
	R=p1[0];
	G=p1[1];
	B=p1[2];

	Y=  2990*R + 5870*G + 1140*B;
	U= -1684*R - 3316*G + 5000*B;
	V=  5000*R - 4187*G -  813*B;

	p1[0]=(Y+5000)/10000;
	p1[1]=(U-5000)/10000+128;
	p1[2]=(V-5000)/10000+128;

	return 0;
}
EXPORT BOOL WINAPI YUVtoRGB (int *p1, int p2, int p3 ,int p4)
{
	int R,G,B,Y,U,V,i;
	Y=p1[0]*10000;
	U=p1[1]-128;
	V=p1[2]-128;

	R= Y +           14020*V;
	G= Y -  3441*U -  7139*V;
	B= Y + 17718*U -    12*V; 

	p1[0]=(R+5000)/10000;
	p1[1]=(G+5000)/10000;
	p1[2]=(B+5000)/10000;

	for(i=0; i<3; i++){
		if (p1[i]<0)   p1[i]=0;
		if (p1[i]>255) p1[i]=255;
	}

	return 0;
}
