#module "RegionFantasy"

;---------------------------
#deffunc rgn_rect int,int,int,int,int
	mref l,0 :lx=l
	mref l,1 :ly=l
	mref l,2 :wx=l
	mref l,3 :wy=l
	mref type,4

	mref s,64
	mref bmscr,67

	if type=0 :ll_getproc@ func_p,"CreateRectRgn",gdi32@
	if type!0 :ll_getproc@ func_p,"CreateEllipticRgn",gdi32@

		a.0=lx
		a.1=ly
		a.2=lx+wx
		a.3=ly+wy
	ll_callfunc@ a,4,func_p

	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_line int,int,int,int
	mref l,0 :lx=l
	mref l,1 :ly=l
	mref l,2 :wx=l
	mref l,3 :wy=l
	mref s,64

	ll_getproc@ crr_p,"CreateRectRgn"  ,gdi32@
	ll_getproc@ com_p,"CombineRgn"     ,gdi32@
	ll_getproc@ del_p,"DeleteObject"   ,gdi32@

	a=0,0,0,0
	ll_callfunc@ a,4,crr_p
	ll_ret@ hmRgn

	x=lx :y=ly :t.1=1
	i=wx-lx :if i<0 :i=-i
	t=wy-ly :if t<0 :t=-t
	if i<t{
		i++
		if wy-ly<0 :a=wx :wx=lx :lx=a :a=wy :wy=ly :ly=a
		if wx-lx<0 :t.1=-1
		x=lx :y=ly
		repeat i
			y.1=t*(cnt+1)/i+ly
			a=x,y,x+1,y.1+1 :y=y.1+1 :x+=t.1
			gosub _CreateRectRgn
		loop
	}else{
		i=t+1
		if wx-lx<0 :a=wx :wx=lx :lx=a :a=wy :wy=ly :ly=a
		if wy-ly<0 :t.1=-1
		t=wx-lx
		x=lx :y=ly
		repeat i
			x.1=t*(cnt+1)/i+lx
			a=x,y,x.1+1,y+1 :x=x.1+1 :y+=t.1
			gosub _CreateRectRgn
		loop
	}
	s=hmRgn

	return

*_CreateRectRgn
	ll_callfunc@ a,4,crr_p
	ll_ret@ hb

	a.0=hmRgn,hmRgn,hb,2
	ll_callfunc@ a,4,com_p
	ll_callfunc@ hb,1,del_p
	return



;---------------------------
#deffunc rgn_round int,int,int,int,int,int
	mref l,0 :lx=l
	mref l,1 :ly=l
	mref l,2 :wx=l
	mref l,3 :wy=l
	mref l,4 :cx=l
	mref l,5 :cy=l

	mref s,64

	ll_getproc@ func_p,"CreateRoundRectRgn",gdi32@
		a.0=lx
		a.1=ly
		a.2=lx+wx
		a.3=ly+wy
		a.4=cx
		a.5=cy
	ll_callfunc@ a,6,func_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_pol val,int
	mref p,16
	mref l,1

	mref s,64

	ll_getproc@ func_p,"CreatePolygonRgn",gdi32@
	ll_getptr@ p :ll_ret@ a
		a.1=l
		a.2=1		;ALTERNATE = 1
				;WINDING = 2
	ll_callfunc@ a,3,func_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_getbox val,int
	mref p,16
	mref l,1

	ll_getproc@ func_p,"GetRgnBox",gdi32@
		a.0=l
		ll_getptr@ p :ll_ret@ a.1
	ll_callfunc@ a,2,func_p

	return
;---------------------------


;---------------------------
#deffunc rgn_copy int,int,int,int
	mref l,0 :hRgn=l
	mref l,1 :ha=l
	mref l,2 :hb=l
	mref l,3 :type=l

	mref s,64

	;RGN_AND  = 1
	;RGN_OR   = 2
	;RGN_XOR  = 3
	;RGN_DIFF = 4
	;RGN_COPY = 5

	if type<1|(type>4)	:i=2
	if type=1		:i=1
	if type=2		:i=3
	if type=3		:i=4
	if type=4		:i=5

	ll_getproc@ com_p,"CombineRgn",gdi32@
		a.0=hRgn
		a.1=ha
		a.2=hb
		a.3=i
	ll_callfunc@ a,4,com_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_move int,int,int
	mref l,0 :hRgn=l
	mref l,1 :x=l
	mref l,2 :y=l
	mref s,64

	ll_getproc@ func_p,"OffsetRgn",gdi32@
		a.0=hRgn
		a.1=x
		a.2=y
	ll_callfunc@ a,3,func_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_window int
	mref l,0 :hRgn=l
	mref s,64
	mref bmscr,67

	ll_getproc@ func_p,"SetWindowRgn",user32@
		a.0=bmscr.13
		a.1=hRgn
		a.2=1
	ll_callfunc@ a,3,func_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_clip int
	mref l,0 :hRgn=l
	mref s,64
	mref bmscr,67

	ll_getproc@ func_p,"SelectClipRgn",gdi32@
		a.0=bmscr.4
		a.1=hRgn
	ll_callfunc@ a,2,func_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_del int
	mref l,0 :hRgn=l
	mref s,64

	ll_getproc@ func_p,"DeleteObject",gdi32@
	ll_callfunc@ hRgn,1,func_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_paint int
	mref l,0 :hRgn=l
	mref s,64
	mref bmscr,67

	ll_getproc@ func_p,"FillRgn",gdi32@
		a.0=bmscr.4
		a.1=hRgn
		a.2=bmscr.36
	ll_callfunc@ a,3,func_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_frame int,int,int
	mref l,0 :hRgn=l
	mref l,1 :w=l
	mref l,2 :h=l
	mref s,64
	mref bmscr,67

	ll_getproc@ func_p,"FrameRgn",gdi32@
		a.0=bmscr.4
		a.1=hRgn
		a.2=bmscr.36
;a.2=0
		a.3=w
		a.4=h
	ll_callfunc@ a,5,func_p
	ll_ret@ a
	s=a

	return
;---------------------------


;---------------------------
#deffunc rgn_load str
	mref f_name,32
	mref s,64

	exist f_name
	if strsize<48 :s=0 :return
	f_size=strsize

	alloc RGNDATA,64
	bload f_name,RGNDATA,32

	x=RGNDATA.4
	y=RGNDATA.5
	w=RGNDATA.6-RGNDATA.4
	h=RGNDATA.7-RGNDATA.5

	ll_getproc@ ext_p,"ExtCreateRegion",gdi32@
	ll_getproc@ crr_p,"CreateRectRgn"  ,gdi32@
	ll_getproc@ com_p,"CombineRgn"     ,gdi32@
	ll_getproc@ del_p,"DeleteObject"   ,gdi32@

	a=0,0,0,0 :ll_callfunc@ a,4,crr_p
	ll_ret@ hmRgn

	repeat f_size-32/64000+1
		alloc RGNDATA,64032

		i=cnt*64000
		rgn_count=f_size-32-(cnt*64000)/16
		if rgn_count>4000 :rgn_count=4000

		bload f_name,RGNDATA,rgn_count*16+32,i

		i=rgn_count*4-1+8
		y.0=RGNDATA.1
		y.1=RGNDATA.i

		RGNDATA=32,1,rgn_count,rgn_count*16,x,y.0,w,y.1

		a.0=0
		a.1=rgn_count*16+32
		ll_getptr@ RGNDATA :ll_ret@ a.2
		ll_callfunc@ a,3,ext_p
		ll_ret@ hRgn

		a.0=hmRgn,hRgn,hmRgn,2
		ll_callfunc@ a,4,com_p
		ll_callfunc@ hRgn,1,del_p
	loop

	alloc RGNDATA,64
	s=hmRgn


	return
;---------------------------
#global

;---------------------------
#module
#deffunc rgn_linepol val,int
	mref p,48
	mref l,1
	mref s,64

	rgn_rect 0,0,0,0 :i=stat
	repeat l-1
		t=cnt+1
		rgn_line p.0.cnt,p.1.cnt,p.0.t,p.1.t :i.1=stat
		rgn_copy i,i.1,i
		rgn_del i.1
	loop

	t=l-1
	rgn_line p.0.t,p.1.t,p.0.0,p.1.0 :i.1=stat
	rgn_copy i,i.1,i
	rgn_del i.1
	s=i

	return
#deffunc rgn_linepol2 val,int
	mref p,48
	mref l,1
	mref s,64

	repeat l-1
		t=cnt+1
		line p.0.cnt,p.1.cnt,p.0.t,p.1.t
	loop

	t=l-1
	line p.0.t,p.1.t,p.0.0,p.1.0

	return

;---------------------------
#global
